FLink = {};

function FLink.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function FLink:load(xmlFile)
	--print("FLINK!");
	self.fLinkNodeL = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fLink#rotationNodeL"));
	self.fLinkNodeR = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fLink#rotationNodeR"));
	local rx, ry, rz = getRotation(self.fLinkNodeL);
	self.defRotL = {rx, ry, rz };
	--print(self.defRotL);
	--print(self.defRotL[1]);
	--print(self.defRotL[2]);
	--print(self.defRotL[3]);
	rx, ry, rz = getRotation(self.fLinkNodeR);
	self.defRotR = {rx, ry, rz };
	--print(self.defRotR);
	--print(self.defRotR[1]);
	--print(self.defRotR[2]);
	--print(self.defRotR[3]);
	
	self.fLinkClosedXRot = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fLink#closedXRot"), 0);
	
	setRotation(self.fLinkNodeL, math.rad(self.fLinkClosedXRot), self.defRotL[2], self.defRotL[3]); 
	setRotation(self.fLinkNodeR, math.rad(self.fLinkClosedXRot), self.defRotR[2], self.defRotR[3]); 
end;

function FLink:delete()
end;

function FLink:readStream(streamId, connection)
end;

function FLink:writeStream(streamId, connection)
end;

function FLink:mouseEvent(posX, posY, isDown, isUp, button)
end;

function FLink:keyEvent(unicode, sym, modifier, isDown)
end;

function FLink:update(dt)
end;

function FLink:updateTick(dt)
end;

function FLink:draw()
end;

function FLink:onLeave()
end;

function FLink:onEnter()
end;

function FLink:attachImplement(implement)
	local jointType = implement.object.attacherJoint.jointType;
	local jointIndex = implement.jointDescIndex;

	if jointType == Vehicle.JOINTTYPE_IMPLEMENT then
		if implement.object.needsLowering then
			self.implementCount = math.max(self.implementCount - 1, 0);
		end;
		if jointIndex == 2 then
			setRotation(self.fLinkNodeL, self.defRotL[1], self.defRotL[2], self.defRotL[3]); 
			setRotation(self.fLinkNodeR, self.defRotR[1], self.defRotR[2], self.defRotR[3]); 
		end;
	elseif jointType == Vehicle.JOINTTYPE_TRAILER then
		if jointIndex == 3 then
		end;
	elseif jointType == Vehicle.JOINTTYPE_TRAILERLOW then
		if jointIndex == 4 then
		end;
	end;

	self.updateJoint = true;
end;

function FLink:detachImplement(implementIndex)
	local implement = self.attachedImplements[implementIndex];
	local jointIndex = implement.jointDescIndex;

	if implement.object.attacherJoint.jointType == Vehicle.JOINTTYPE_IMPLEMENT then
		if implement.object.needsLowering then
			self.implementCount = self.implementCount + 1;
		end;
		if jointIndex == 2 then
			setRotation(self.fLinkNodeL, math.rad(self.fLinkClosedXRot), self.defRotL[2], self.defRotL[3]); 
			setRotation(self.fLinkNodeR, math.rad(self.fLinkClosedXRot), self.defRotR[2], self.defRotR[3]); 
		end;
	else
	end;
	
	self.updateJoint = true;
end;

function FLink:validateAttacherJoint(implement, jointDesc, dt)
    if self.updateJoint then
        self.updateJoint = false;
        return true;
    end;
    return false;
end;
